import java.io.*;
import java.net.*;
import java.lang.String.*;
import java.lang.Object.*;
import java.util.zip.*;


/*this is the main monitor class- 
for the present situation since whole protocol is not simulated a separate monitor class for sender and receiver is done.
It has the following data types

 n- window.
 f,r ,totel - the front rear and totel elements of window.
 A byte mesg for sending and receiving messages.
 other data types are used for programming convenience.
*/


class rdpProtocolClient
 {
   static int f, r,totel,elno,recv,error;
   DatagramSocket soc,soc1;
   DatagramPacket data,data1;
   static InetAddress dest;
   static byte mesg[]=new byte[1024];
   static String rec,recd,recack;
   static int windowsize=16;
   String n[]= new String[16];
   String n1[]= new String[64];
   String s[]=new String[64];
   String win[]=new String[16];
   int seqnum[]=new int[32];           
   PrintStream p;
   FileOutputStream fos;
   FileInputStream fis;
   CRC32 chksum;
   String recs[];
   long l;	
	/*the constuctor where initialisation for Files  and Print streams are done*/

   rdpProtocolClient()
    {
		f=0; r=0;totel=0;error=0;
		rec="no news";
		recack="no errors";
		for(int i=0;i<windowsize;i++)
		 n[i]="#";
		 try
		{
		fos= new FileOutputStream("sentfile.txt");
	    fos.close();
		}catch(IOException ioe){}
    }

/*this function takes care of the sender window functions like updating when ack packet is received*/

void windowcheck(String a)
{
  for(int i=0;i<windowsize;i++) 
   {
	if(n[i]=="#")
	   {
			n[i]=a;
		    seqnum[elno]=i;
			break;
	   }
	}
}

void calc(int j)
	 {
		if(j>10)
		 {
			for(int i=j-10;i<=j+6;i++)
			 {
				String inp1="test"+i;
				chksum=  new CRC32();
				byte ck[]=new byte[1024];
				
				String stra1=Integer.toString(i);
				ck=stra1.getBytes();
				chksum.update(ck);
				l=chksum.getValue();
				n1[i%16]=i+"#"+Long.toString(l)+"#"+inp1;
			 }
		 }
		 else
		 {
			for(int i=j;i<=j;i++)
			 {
				String inp1="test"+i;
				chksum=  new CRC32();
				byte ck[]=new byte[1024];
				String stra1=Integer.toString(i);
				ck=stra1.getBytes();
				chksum.update(ck);
				l=chksum.getValue();
				n1[i%16]=i+"#"+Long.toString(l)+"#"+inp1;
			 }
		}
	 }

/*this function is just used to send a packet to a destined port*/
void sendPacket(String msg,int port)
{
			try
			{		
			soc=new DatagramSocket();		    
 		    mesg=msg.getBytes();
			dest=InetAddress.getByName("localhost");
			data=new DatagramPacket(mesg,mesg.length,dest,port);
			//windowcheck(msg);
			soc.send(data);
			elno++;  totel++;
			if (elno==16){ elno=0;}
			soc.close();
			}catch(Exception e){}
}

/*this function is used to receive packet from a port*/
void receivePacket(int port)
{			
			try
			{
			soc1=new DatagramSocket(port); 
			dest=InetAddress.getByName("localhost");
			data1=new DatagramPacket(mesg,mesg.length,dest,port);
			soc1.receive(data1);
		    totel--;
			rec=new String(data1.getData());
			recd= rec.substring(0,rec.indexOf("#"));
			recack=rec.substring(rec.indexOf("#")+1,rec.indexOf((char)'#')+5);
			recv=Integer.parseInt(recd);
 			//System.out.println("ACK for packet number: "+rec+"\n\n");
			System.out.println("\nRecd ack is"+ recack+"\n");
			soc1.close();
			}catch(Exception e){System.out.println("Socke Exc."+ e);}
}



/*this is a synchronised funcction called by sending threads which then calls the sendPacket () function to send data*/

synchronized  void sendPacketRDP(int a,int file)
    {      
		
		if(elno>6)
     	try
	      { wait(); /* waiting if Window is full*/
		  }	catch(Exception e){System.out.println("Exception is "+ e);}
			
			try{Thread.sleep(300);}catch(Exception e){}
			String inp, temp2;
			if(file!=0)//if not to read from file.
			{
				
				
				try
				{
				BufferedReader br= new BufferedReader(new FileReader("sentfile1.txt"));
				int x=0;
				while((s[x]=br.readLine())!=null){x++;};
				}catch(Exception e){System.out.println("File Exception is " + e);}
				inp=s[a].substring(s[a].lastIndexOf(" "),s[a].length());
				n[r]=inp;
				String stra=Integer.toString(a);
				chksum=  new CRC32();
				byte ck[]=new byte[1024];
				ck=stra.getBytes();
				chksum.update(ck);
				l=chksum.getValue();
				temp2=Long.toString(l)+" "+s[a].substring(0,5);
				n[r]=a+"#"+Long.toString(l)+"#"+inp;
				win[a%16]=n[r];
				System.out.println("sent msg="+ s[a].substring(s[a].lastIndexOf(" "),s[a].length()) );

	     	}
		else
			{
				
				calc(a);
				inp="test"+a;
				System.out.println("sent msg="+ inp );
				win[a%16]=inp;
				String stra=Integer.toString(a);
				n[r]=a+"#"+Long.toString(l)+"#"+inp;
				chksum=  new CRC32();
				byte ck[]=new byte[1024];
				ck=stra.getBytes();
				chksum.update(ck);
				l=chksum.getValue();
			
				
				String temp=new String("1111");
				String temp1=new String( recack.substring( recack.length()-4,recack.length()) );
				if(recack.compareTo(new String("no errors")) !=0)
				if(temp1.compareTo(temp) !=0)
				{
					for(int x=0;x<4;x++)
					{
						if(temp1.charAt(x)==(char)'0') 
						{
							
						sendPacket(n1[r -(4-x)-1],1800);
						elno--;
						try{Thread.sleep(200);}catch(Exception e){}
						}
	
					}
					recack="no errors";
				}


				try
				{
				 fos= new FileOutputStream("sentfile.txt",true);
				 p= new PrintStream(fos);//writing data randomly produced to file.
				 p.println("DATA time "+ a + Long.toString(l)+" "+inp);
				 fos.close();
				 p.close();
				 		 
				}catch(IOException ioe){}
			}
	
		sendPacket(n[r],1800); //# used to separate data from sequence number
		try{Thread.sleep(300);}catch(Exception e){}
		r++;
	    r=r%16;
		notify();
     
	}
 
   /*this receive function is also called by the synchronised received thread and it then calls the receivePacket() function*/

synchronized int receivePacketRDP()
   {
         
      for(int x=0;x<4;x++)
		{
		if(recack.charAt(x)=='1') { elno--;}
		else {error=1;elno--;}
		}
     notify();	//to notify waiting 
     return(recv);
   }
}




/*this class extends thread to call a sending function*/

class cliSend extends Thread  
  {
   rdpProtocolClient q;
   cliSend(rdpProtocolClient q)
    { this.q=q;  }
   public void run()
    {
     int i=0;
	while(i<16)
      {	
		 
		 q.sendPacketRDP(i,0); i++; 
		 
		}

	 i=15;
	 while(i<21)
      { 
		 q.sendPacketRDP(i,0); i++; 
	}
	 i=22;
	 while(i<32)
      { 
		q.sendPacketRDP(i,0); i++; 
	 	}
	 
    }   
  }



/* this class extends thread to call a receiving function*/

class cliRecvr extends Thread
  {  
   rdpProtocolClient q;
   cliRecvr(rdpProtocolClient q)
    {this.q=q;}
   public void run()
    {  
     int a;
     while(true)
      {  q.receivePacket(1700);// call to receive data
	  	 a=q.receivePacketRDP(); //call to window management
	  }    
    }
  }


/*the main client class which creates an object of monitor class. and initiates the two sending and receiving threads*/
class client
{

  public static void main(String args[])
   {
   rdpProtocolClient q= new rdpProtocolClient();
    
		  byte m[]= new byte[100];
		

				
		cliSend p = new cliSend(q);
		cliRecvr c= new cliRecvr(q);
	    c.start();
		p.start();
   
   
     }
   }
    
   
