import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.lang.Object.*;
import java.util.zip.*;


/*this is the main monitor class- 
for the present situation since whole protocol is not simulated, a separate monitor class for sender and receiver is done.
It has the following data types

 n- window.
 f,r ,totel - the front rear and totel elements of window.
 A byte mesg for sending and receiving messages.
 recv is the seqnum of the data received.
 other data types are used for programming convenience.

*/

class rdpProtocol
 {
   String n[]= new String[100];
   static String sen;
   int f, r,totel,res=0,dup=0,oo=0,lp=0;
   DatagramSocket soc,soc1;
   DatagramPacket data,data1;
   static InetAddress dest;
   static byte mesg[]=new byte[1024];
   static byte mesg1[]=new byte[1024];
   static String rec,prev,curr,rec1,rs,chk,recd;
   static int seqno,seqnp,seqnn,ind,totno,oor,chr,seqmax,totrec=0;            
   int seq[]=new int[64];
   char ackbit[]=new char[16];
   long l;
   PrintStream p;
   FileOutputStream fos;
   CRC32 chksum;
   String recs[];
   

	/*the constuctor where initialisation for Files  and Print streams are done*/

   rdpProtocol()
    {
      f=0; r=0;totel=0;ind=0;seqno=0;seqmax=0;prev="";sen="";seqnp=-1;seqnn=0;oor=0;
	  prev=null;
	  try
		{
		 fos= new FileOutputStream("recdfile.txt");
		 fos.close();
		 

		}catch(IOException ioe){}
   }


	/*this function is just used to send a packet to a destined port*/

  void sendPacket(String msg,int port)
	{
			try
			{		
			soc=new DatagramSocket();		    
	    	mesg1=msg.getBytes();
			dest=InetAddress.getByName("localhost");
			data=new DatagramPacket(mesg1,mesg1.length,dest,port);
			soc.send(data);
			seqno=0;
	 		soc.close();
			}catch(Exception e){}
	}


	/*this function is used to receive packet from a port*/
  void receivePacket(int port)
	{			
			try
			{
			soc1=new DatagramSocket(port); 
			dest=InetAddress.getByName("localhost");
			data1=new DatagramPacket(mesg,mesg.length,dest,port);
			soc1.receive(data1);
			rec=new String(data1.getData());
			rec1=rec.substring(rec.lastIndexOf("#")+1,rec.length());
			chk= rec.substring(rec.indexOf("#")+1, rec.lastIndexOf("#") );
			 recd= rec.substring(0,rec.indexOf((char)'#'));
			seqno=Integer.parseInt(recd);
			recs=rec.split("#");
			
			ind++;if(ind==16) ind=0;
			n[seqno]=rec1;
			soc1.close();
			}catch(Exception e){}
			//duplicate packets.
			
	}
	void checkPacket()
	 {
			
	 
			if(seqno==seqnp)
		 {
				System.out.println("Duplicate MESSAGE IS : "+rec1);
				seq[totno]=seqno;
				ackbit[totno%16]='1';
				totno++;
				totrec++;
				if(seqno>seqmax) seqmax=seqno;
				seqnp=seqno;
				seqnn=seqnp+1;
		 }
			else  if(seqno==seqnp+2)
				{
		    		int c=seqno-1;

					System.out.println("Lost Packet"+ c);
					ackbit[totno%16]='0';
					totno++;
					System.out.println("MESSAGE IS : "+rec1);
					ackbit[totno%16]='1';
					seq[totno]=seqno;
					totno++;
					totrec++;lp++;
					if(seqno>seqmax) {seqmax=seqno;}
					seqnp=seqno;
					seqnn=seqnn+2;
				}

			else if( seqno<seqnp )
				{
				ackbit[totno%16]='1';
				totno++;    
				 
				 
				System.out.println("Resent  data"+ Integer.toString(seqno));
				if(seqno>seqmax) seqmax=seqno;
				seqnp=seqno+2;
				seqnn=seqnp+4;
				totrec++;
				//seqnp++;
				 rs="1";
				res=1;
				}
			else if(seqno>seqnn)
		 {
				ackbit[totno%16]='1';
				totno++;    
				System.out.println("Out of order"+ Integer.toString(seqno));
				if(seqno>seqmax) seqmax=seqno;
				seqnp=seqno;
				seqnn=seqnp+2;
				totrec++;
				
				 rs="1";
				res=1;
		 }
			else //if(seqno==seqnp+1)
				{
				System.out.println("MESSAGE IS : "+rec1);
				
				seq[totno]=seqno;
				ackbit[totno%16]='1';
				totno++;
				totrec++;
				if(seqno>seqmax) seqmax=seqno;
				seqnp=seqno;
				seqnn=seqnp+1;;
				}
		  
			
			
	}


void getack()
	 {
		
		sen=seqmax+new String("#");
		if(res==1)
		sen= sen+rs;
		res=0;
		 
		sen= sen+new String(ackbit);
		sen=sen+new String("#");
		System.out.println("ack is "+sen);
		
	 }

	/*this is a synchronised funcction called by sending threads which then calls the sendPacket () function to 
	send data back to cleint ans ACK*/
	


  synchronized void  sendPacketRDP()
    {      
     if(totno<=4)
     try
      {
       System.out.println("\n\nserver send waiting\n\n");
       wait();  
      }
     catch(Exception e)
      {
       System.out.println("Exception is "+ e);
      }
	  getack();
	   try{Thread.sleep(150);}catch(Exception e){}
		  sendPacket(sen,1700);//call to send packet
	     n[r]=rec;
		 r++;
    r=r%3;
     
	totrec=0;
	totno=0;
    notify();
   }
 
	/*this is a synchronised funcction called by receiving threads which then calls the receivePacket ()
	 function to receive data from client*/

  synchronized int receivePacketRDP()
   {
	 	
    int a=0;
	chksum=  new CRC32();
	String stra=recd+rec1;
	chksum.update(recd.getBytes());
	l=chksum.getValue();
    String curr=recs[2];
	curr.trim();
	try
	{
 	 fos= new FileOutputStream("recdfile.txt",true);
      p= new PrintStream(fos);
	   
      if( (curr != prev) )
	    {p.print("DATA time " +seqno+ Long.toString(l));
		 p.flush();
		 p.println(" "+curr);
		
		}//writing data received to file
   	  fos.close();
	  p.close();
	  prev=curr;
   	}catch(IOException ioe){}
	
	
		if((totno-lp)>3)
	   {
			dup=0;oo=0;lp=0;
      notify();
	   }
		
      return(a);
  }

}

/*this class extends thread to call a sending function*/

class serSend extends Thread  
  {
   rdpProtocol q;
   serSend(rdpProtocol q)
    {
 
     this.q=q;   
    }

   public void run()
    {
     int i=0;
     while(true)
      {
    
       q.sendPacketRDP();
      }
    }  
  }


/* this class extends thread to call a receiving function*/
class serRecvr extends Thread
  {  
   rdpProtocol q;
   serRecvr(rdpProtocol q)
    {   
     this.q=q;
    }
   public void run()
    {  
     int a;
     while(true)
      {
			 q.receivePacket(1800);
			 q.checkPacket();
			  a=q.receivePacketRDP(); 
      } 
    }
  }
 

   
/*the main client class which creates an object of monitor class. and initiates the two sending and receiving threads*/
class server
{

  public static void main(String args[])
   {
	 
   rdpProtocol q= new rdpProtocol();
   int a,i=0;
   serSend p = new serSend(q);
   serRecvr c= new serRecvr(q);
   p.start();
   c.start();
   
	
   }
 }
  
   
